import os
import sys

sys.path.append(os.path.join(os.path.dirname(__file__), '..'))
from pydatadeck.datasource.filter import filter


def test_filter():

    rows = [
        [1, 'hello'],
        [2, None],
        [3, 'world']
    ]

    fids = ['f1', 'f2']

    r = filter(rows, fids, [
        {'fieldId': 'f3', 'operator': 'equal', 'values': [2]}])
    assert len(list(r)) == 3

    r = filter(rows, fids, [
        {'fieldId': 'f1', 'operator': 'equal', 'values': [2]}])
    assert len(list(r)) == 1

    r = filter(rows, fids, [
        {'fieldId': 'f1', 'operator': 'equal', 'values': [4]}])
    assert len(list(r)) == 0

    r = filter(rows, fids, [
        {'fieldId': 'f1', 'operator': 'not_equal', 'values': [2]}])
    assert len(list(r)) == 2

    r = filter(rows, fids, [
        {'fieldId': 'f1', 'operator': 'in_list', 'values': [0, 2]}])
    assert len(list(r)) == 1

    r = filter(rows, fids, [
        {'fieldId': 'f1', 'operator': 'in_list', 'values': [1, 2]}])
    assert len(list(r)) == 2

    r = filter(rows, fids, [
        {'fieldId': 'f1', 'operator': 'not_in_list', 'values': [2]}])
    assert len(list(r)) == 2

    r = filter(rows, fids, [
        {'fieldId': 'f1', 'operator': 'is_null', 'values': []}])
    assert len(list(r)) == 0

    r = filter(rows, fids, [
        {'fieldId': 'f2', 'operator': 'is_null', 'values': []}])
    assert len(list(r)) == 1

    r = filter(rows, fids, [
        {'fieldId': 'f2', 'operator': 'is_not_null', 'values': []}])
    assert len(list(r)) == 2

    r = filter(rows, fids, [
        {'fieldId': 'f2', 'operator': 'str_contain', 'values': ['el']}])
    assert len(list(r)) == 1

    r = filter(rows, fids, [
        {'fieldId': 'f2', 'operator': 'str_not_contain', 'values': ['el']}])
    assert len(list(r)) == 2

    r = filter(rows, fids, [
        {'fieldId': 'f2', 'operator': 'str_begin_with', 'values': ['he']}])
    assert len(list(r)) == 1

    r = filter(rows, fids, [
        {'fieldId': 'f2', 'operator': 'str_not_begin_with', 'values': ['he']}])
    assert len(list(r)) == 2

    r = filter(rows, fids, [
        {'fieldId': 'f2', 'operator': 'str_end_with', 'values': ['llo']}])
    assert len(list(r)) == 1

    r = filter(rows, fids, [
        {'fieldId': 'f2', 'operator': 'str_not_end_with', 'values': ['llo']}])
    assert len(list(r)) == 2

    r = filter(rows, fids, [
        {'fieldId': 'f2', 'operator': 'regex_match', 'values': ['.+ell.+']}])
    assert len(list(r)) == 1

    r = filter(rows, fids, [
        {'fieldId': 'f2', 'operator': 'regex_not_match', 'values': ['.+ell.+']}])
    assert len(list(r)) == 2

    r = filter(rows, fids, [
        {'fieldId': 'f1', 'operator': 'gt', 'values': [2]}])
    assert len(list(r)) == 1

    r = filter(rows, fids, [
        {'fieldId': 'f1', 'operator': 'ge', 'values': [2]}])
    assert len(list(r)) == 2

    r = filter(rows, fids, [
        {'fieldId': 'f1', 'operator': 'lt', 'values': [2]}])
    assert len(list(r)) == 1

    r = filter(rows, fids, [
        {'fieldId': 'f1', 'operator': 'ge', 'values': [2]}])
    assert len(list(r)) == 2

    r = filter(rows, fids, [
        {'fieldId': 'f1', 'operator': 'gt', 'values': [2]},
        {'fieldId': 'f2', 'operator': 'equal', 'values': ['world']}])
    assert len(list(r)) == 1
